# compute_none.py
# author: Marko Borazio for ESS, TU Darmstadt
# Nov 2012
# description:
# no features selected for computation

import numpy as np

#load the dataset GTUS 2001/2002
dta = np.array(np.load('datasets/gtud.npy'), np.byte )
ref = np.array(np.load('datasets/ref.npy'))
dta = np.sum(dta,1)

hh=list(set(ref[:,0]))						# list of all households (HH)
conf = np.zeros((len(hh),11,11),int)	# confusion matrix: HH, 11 activities

#get histogram
hst = np.zeros((11),int)		
hst = np.histogram(dta,bins=range(1,13))[0]
	
# i = HH counter
# hhid = household ID
for i, hhid in enumerate(hh):
	ind = np.where(ref[:,0] == hhid)
	hsta = np.array(hst)			# init histogram
	hsta -= np.histogram(dta[ind],bins=range(1,13))[0] #adjust histogram
		
	# fill confusion matrix:			
	conf[i,np.argmax(hsta)] += np.histogram(dta[ind],bins=range(1,13))[0]	 
			
np.save('conf_none.npy',conf)
