# compute_prev.py
# author: Marko Borazio for ESS, TU Darmstadt
# Nov 2012
# description:
# previous activity computation

import numpy as np
import itertools
import time_use as tu


#load the dataset GTUS 2001/2002
dta = np.array(np.load('datasets/gtud.npy'), np.byte )
ref = np.array(np.load('datasets/ref.npy'),int)

#get rid of location information
dta = np.sum(dta,1)

hh=list(set(ref[:,0]))						# number of households
conf = np.zeros((len(hh),11,11),int)	# confusion matrix

#create histogram
hst = np.zeros((11,11),int)
# ucnt = user counter		
# u = time-slot and activity of the user
for ucnt, u in enumerate(dta):
	foo = tu.get_unique(u)
	# tcnt = counter for time-slot
	# act = performed activity at time-slot tcnt
	for tcnt, act in enumerate(foo):
		if tcnt+1 == foo.size:
			break
		hst[act-1,foo[tcnt+1]-1] += 1

# i = HH counter
# hhid = household ID
for i, hhid in enumerate(hh):
	rw = np.zeros(dta.shape[0],bool)
	rw[ref[:,0]==hhid] = True
	hsta = np.array(hst)			# init histogram
	# ucnt = user counter
	# u = user data
	for ucnt, u in enumerate(dta[rw]):
		foo = tu.get_unique(u)
		# adjust histogram per activity code
		for tcnt, act in enumerate(foo):
			if tcnt+1 == foo.size:
				break
			hsta[act-1,foo[tcnt+1]-1] -= 1
			
	for ucnt, u in enumerate(dta[rw]):
		foo = tu.get_unique(u)
		for tcnt, act in enumerate(foo):
			if tcnt+1 == foo.size:
				break
			# fill confusion matrix
			conf[i,np.argmax(hsta[act-1,:]),foo[tcnt+1]-1] += 1 
		
#save results
np.save('conf_prev.npy',conf)
