# compute_time.py
# author: Marko Borazio for ESS, TU Darmstadt
# Nov 2012
# description:
# time of day computation

import numpy as np

#load the dataset GTUS 2001/2002
dta = np.array(np.load('datasets/gtud.npy'), np.byte )
ref = np.array(np.load('datasets/ref.npy'))
dta = np.sum(dta,1)

hh=list(set(ref[:,0]))						# number of households
conf = np.zeros((len(hh),11,11),int)	# confusion matrix

# compute histogram per time slot
hst = np.zeros((np.size(dta,1),11))
for i,u in enumerate(dta.T): 
	for j in u: 
		hst[i,j-1] += 1

# i = HH counter
# hhid = household ID
for i, hhid in enumerate(hh):
	rw = np.zeros(dta.shape[0],bool)
	rw[ref[:,0] == hhid] = True
	hsta = np.array(hst)			# init histogram
	# k = user counter
	# usr = user of the household
	for k, usr in enumerate(dta[rw]):
		# l = activity label index
		# v = actual activity label for current user
		for l,v in enumerate(usr):
			hsta[l,v-1] -= 1				# correct histogram (removing the user)
		
	# compare user activity label with the "most common activity" from histogram
	# w = each user of the household
	for w in dta[rw]:
		# l = iterator for w
		# p = histogram activity code per timeslot
		for l,p in enumerate(np.argmax(hsta,1)):
			# fill confusion matrix
			conf[i,p,w[l]-1] += 1
		
#save results
np.save('conf_time.npy',conf)
